C This code was released into the public domain by Peter McCluskey on 6/2/2000.
C It is based in part on code released into the public domain by
C Donald Brenner on 2/29/2000.
      subroutine inputd(kflag0,pseed0,rll0,tem0,ipot0)
      IMPLICIT REAL*8(A-H,O-Z)
      include 'common_files.inc'
      call setin
C
C Init data corresponding to input.d
C
      kvc=0
      maxkb=0
      kflag=kflag0
      pseed=pseed0
      rll=rll0
      tem=tem0

C  =1 REBO (C,H,Si,Ge), =2 tight-binding for C 
      ipot=ipot0

C carbon
      xmass(1) = 12.0D0
      eps(1,1) = 51.2D0
      sig(1,1) = 2.28D0
C hydrogen
      xmass(2) = 1.0D0
      eps(2,2) = 8.6D0
      sig(2,2) = 2.81D0
      ktmax = 4
C  6    12.0   51.2   2.28    / carbon Lennard-Jones parameters 
C  1     1.0    8.6   2.81    / 
C
      ilj = 1

      return
      end

      subroutine kldg1(x)
      IMPLICIT REAL*8(A-H,O-Z)
      include 'common_files.inc'
      x = r0(8,1)
      return
      end

C Initialize coordinate, time data

      subroutine coordd(pos0,vel0,acc0,r30,r40,itr0,numat,numat0,t0,
     & delta0,cube0)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 pos0(3,numat0),vel0(3,numat0),r40(3,numat0),acc0(3,numat0),
     & cube0(3),r30(3,numat0)
      INTEGER itr0(numat0),numat(numat0)
      include 'common_files.inc'

      np=numat0
      TTIME=t0
      DELTA=delta0
      cube(1)=cube0(1)
      cube(2)=cube0(2)
      cube(3)=cube0(3)

      if(np.gt.npmax) then
           write(*,*) 'np= ',np,' greater than npmax= ',npmax
           write(*,*) 'increase npmax and recompile'
           stop
      endif

      nma = 0
      nta = 0

      DO k=1,NP
           do n=1,3
                R0(k,n) = pos0(n,k)
                if(R0(K,N).gt.cube(n)/2.0d0) R0(K,N)=R0(K,N)-cube(n)
           enddo
           itr(k) = itr0(k)
           KTYPE(k)=KT(numat(k))

           if(ktype(k).eq.0) then
                write(6,*) 'unknown atom type for atom ',i,
     & ' atomic no',numat(k)
                stop
           endif
           noa(ktype(k)) = noa(ktype(k)) + 1

C
c set up list of nonrigid and thermostated atoms
           if(itr(k).ne.2) then
                nma = nma + 1
                mlist(nma) = k
                if(itr(k).eq.1) then
                     nta = nta + 1
                     nlist(nta) = k
                endif
           endif
c
      ENDDO
C
      DO I=1,NP
           DO N=1,3
                R1(I,N)=vel0(N,i)*DELTA
                R2(I,N)=acc0(N,i)
                R3(I,N)=r30(N,i)
                R4(I,N)=r40(N,i)
           ENDDO
      ENDDO
C
C ESTABLISH INITIAL POSITIONS FOR NEIGHBOR LIST UPDATE
C
      DO 8 I=1,3
           DO 7 J=1,NP
                R0L(J,I)=R0(J,I)
7          CONTINUE
8     CONTINUE
C
      VOL=CUBE(1)*CUBE(2)*CUBE(3)
C
      DO 6 I=1,3
           CUBE2(I)=CUBE(I)/2.0D0
6     CONTINUE
C
      DELTSQ=DELTA*DELTA/2.0D0
      TTCONV=2.0d0/3.0d0/FLOAT(NP)


C
C Zero bicubic spline coefficients
C
      DO 125 I=1,2
           DO 124 L=1,10
                DO 123 M=1,10
                     DO 122 J=1,16
                          CLM(I,L,M,J)=0.0
122                  CONTINUE
123             CONTINUE
124        CONTINUE
125   CONTINUE
      return
      end 

      SUBROUTINE PARAM
      write(*,*) 'Error - subroutine param called in library version'
      stop
      return
      end 

      subroutine csetmi
      IMPLICIT REAL*8(A-H,O-Z)
      include 'common_files.inc'
      kvc = 1
      return
      end

      subroutine csetmd
      IMPLICIT REAL*8(A-H,O-Z)
c
      include 'common_files.inc'

            IF(NMA.ne.0) THEN
                  ENPR=EPSI/FLOAT(NMA)
            ELSE
                 ENPR=0.0D0
            ENDIF
C
            xkea = 0.0d0
            time = 0.0d0
            lchk = 1
            end 

      subroutine csetpp

      IMPLICIT REAL*8(A-H,O-Z)
c
      include 'common_files.inc'

      if(ipot.eq.1) then
           CALL CPARAM()
           call mtable
      endif
      if(ilj.ne.0) call ljparam
      call ljcset
c setup predictor-corrector coefficients
      call setpc 
      return
      end 

      SUBROUTINE SETXH(I,J,K,XHH)
      IMPLICIT REAL*8(A-H,O-Z)
      include 'common_files.inc'
      XH(I,J,K) = XHH
      return
      end 

C read integer values of bicubic spline

      SUBROUTINE SETCLM(I,L,M,J,CLM1,CLM2,CLM3,CLM4)
      IMPLICIT REAL*8(A-H,O-Z)
      include 'common_files.inc'
      CLM(I,L,M,J) = CLM1
      CLM(I,L,M,J+1) = CLM2
      CLM(I,L,M,J+2) = CLM3
      CLM(I,L,M,J+3) = CLM4
      return
      end 

      SUBROUTINE SETCL2(I,L,M,N,J,CLMN1)
      IMPLICIT REAL*8(A-H,O-Z)
      include 'common_files.inc'
      CLMN(I,L,M,N,J) = CLMN1
      return
      end 

C tricubic spline coefficients for torsional potential
      SUBROUTINE SETT(L,M,N,I,TLMN1)
      IMPLICIT REAL*8(A-H,O-Z)
      include 'common_files.inc'
      TLMN(L,M,N,I) = TLMN1
      return
      end 


C
C Equivalent of much of param.f
C
      SUBROUTINE CPARAM
C Parameters for hydrocarbons
C
      IMPLICIT REAL*8(A-H,O-Z)
      include 'common_files.inc'
c
C
      data spgc/
     &  0.2817216000000D+00, 0.1062912000000D+01, 0.2136736000000D+01,
     &  0.2533952000000D+01, 0.1554736000000D+01, 0.3863296000000D+00,
     &  0.2817216000000D+00, 0.1062912000000D+01, 0.2136736000000D+01,
     &  0.2533952000000D+01, 0.1554736000000D+01, 0.3863296000000D+00,
     &  0.6900668660000D+00, 0.5460691360000D+01, 0.2301345680000D+02,
     &  0.5491519344000D+02, 0.6862037040000D+02, 0.3470897779200D+02,
     &  0.3754490870000D+00, 0.1407252749388D+01, 0.2255103926323D+01,
     &  0.2028902219952D+01, 0.1426981217906D+01, 0.5063107994308D+00,
     &  0.2718558000000D+00, 0.4892727456293D+00,-0.4328199017473D+00,
     & -0.5616795197048D+00, 0.1270874966906D+01,-0.3750409108350D-01/
C
      DATA IGC/16*4,2*3,2*2,5*1/
C
      DATA SPGH/270.467795364007301D0,1549.701314596994564D0
     &,3781.927258631323866D0,4582.337619544424228D0,
     &2721.538161662818368D0,630.658598136730774D0,
     &16.956325544514659D0,-21.059084522755980D0,
     &-102.394184748124742D0,-210.527926707779059D0,
     &-229.759473570467513D0,
     &-94.968528666251945D0,19.065031149937783D0,2.017732531534021D0,
     &-2.566444502991983D0,3.291353893907436D0,-2.653536801884563D0,
     &0.837650930130006D0/
C
      DATA IGH/18*3,4*2,3*1/
C
      DATA XH/200*0.0/,XH1/200*0.0/,XH2/200*0.0/
C
      DATA ATT/3.20D0/,XQM/3.70D0/
C
C
      XH1(2,3,1)=(XH(2,4,1)-XH(2,2,1))/2.0D0
      XH1(2,2,2)=(XH(2,3,2)-XH(2,1,2))/2.0D0
C
      XH2(2,2,2)=(XH(2,2,3)-XH(2,2,1))/2.0D0
      XH2(2,1,3)=(XH(2,1,4)-XH(2,1,2))/2.0D0
C
      IC=0
C
      DO 140 L=1,10
           DO 139 M=1,10
                DO 138 N=4,10
                     DO 137 I=1,64
                          TLMN(L,M,N,I)=TLMN(L,M,3,I)
137                  CONTINUE
138             CONTINUE
139        CONTINUE
140   CONTINUE
C
      DO 9 I=1,4
           DO 8 J=1,4
                     IC=IC+1
                     IN2(IC,1)=I-1
                     IN2(IC,2)=J-1
8               CONTINUE
9         CONTINUE
C
C Read tricubic spline coefficients
C
      IC=0
C
      DO 7 I=1,4
           DO 6 J=1,4
                DO 5 K=1,4
                     IC=IC+1
                     IN3(IC,1)=I-1
                     IN3(IC,2)=J-1
                     IN3(IC,3)=K-1
5               CONTINUE
6         CONTINUE
7     CONTINUE
C


      PQ=PI/(XQM-ATT)

      do i=1,4
          do j=1,4
               AD(i,j)  = 0.0d0
               AXL(i,j) = 0.0d0
               BD(i,j)  = 0.0d0



               BXL(i,j) = 0.0d0
               CD(i,j)  = 0.0d0
               CXL(i,j) = 0.0d0
               DD(i,j)  = 0.0d0
               DXL(i,j) = 0.0d0
               ED(i,j)  = 0.0d0
               RB1(i,j) = 0.0d0
               RB2(i,j) = 0.0d0
               RMAX(i,j) = 0.0d0
               PID(i,j) = 1.0d0
               CHI(i,j) = 1.0d0
               do k = 1,4
                xdb(i,j,k) = 0.0d0
               enddo
          enddo
      enddo

C
C*** IMPORTANT***************
C                           *
C TO INCLUDE DIHEDRAL TERMS *
C SET NDIHED=2, OTHERWISE   *
C SET NDIHED=10             *
C                           *
C****************************
C
      NDIHED=2
C
C CARBON
C
      AD(1,1)=12388.79197798375D0
      AXL(1,1)=4.720452312717397D0
      BD(1,1)=17.56740646508968D0
      BXL(1,1)=1.433213249951261D0
      CD(1,1)=30.71493208065162D0
      CXL(1,1)=1.382691250599169D0
      DD(1,1)=10953.54416216992D0
      DXL(1,1)=4.746539060659529D0
      ED(1,1)=0.3134602960832605d0
      RB1(1,1)=1.7d0
      RB2(1,1)=2.0d0
      RMAX(1,1)=RB2(1,1)
      PID(1,1)=PI/(RB2(1,1)-RB1(1,1))
C
C Hydrogen
C
      AD(2,2)=29.6325931D0
      AXL(2,2)=1.715892169856421D0
      BD(2,2)=0.0D0
      BXL(2,2)=1.0D0
      CD(2,2)=0.0D0
      CXL(2,2)=1.0D0
      DD(2,2)=32.81735574722296D0
      DXL(2,2)=3.536298648376465D0
      ED(2,2)=0.3704714870452888d0
c 
      RB1(2,2)=1.10d0


      RB2(2,2)=1.70d0
      RMAX(2,2)=RB2(2,2)
      PID(2,2)=PI/(RB2(2,2)-RB1(2,2))
C
c CARBON-HYDROGEN
C
       AD(2,1)=32.35518665873256D0
       AXL(2,1)=1.434458059249837D0
       DD(2,1)=149.9409872288120D0
       DXL(2,1)= 4.102549828548784D0
       ED(2,1)=0.3407757282257080D0
c
      BD(2,1)=0.0D0
      BXL(2,1)=1.0D0
      CD(2,1)=0.0D0
      CXL(2,1)=1.0D0
C
      AD(1,2)=AD(2,1)
      AXL(1,2)=AXL(2,1)
      BD(1,2)=BD(2,1)
      BXL(1,2)=BXL(2,1)
      CD(1,2)=CD(2,1)
      CXL(1,2)=CXL(2,1)
      DD(1,2)=DD(2,1)
      DXL(1,2)=DXL(2,1)
      ED(1,2)=ED(2,1)
C
      RB1(2,1)=1.3d0
      RB2(2,1)=1.8d0
      RMAX(2,1)=RB2(2,1)
      PID(2,1)=PI/(RB2(2,1)-RB1(2,1))
      PIDT=PI/0.30D0
C
      RB1(1,2)=RB1(2,1)
      RB2(1,2)=RB2(2,1)
      RMAX(1,2)=RB2(1,2)
      PID(1,2)=PI/(RB2(1,2)-RB1(1,2))
C
      DO 12 I=1,2
           DO 11 J=1,2
                DO 10 K=1,2
                     XDB(I,J,K)=0.0d0
                     REG(I,J,K)=1.0d0
10              CONTINUE
11         CONTINUE
12    CONTINUE 
C
      XXDB=4.0D0
      RHH=0.7415886997d0
      RCH=1.09d0
      XDB(2,2,2)=4.0D0
C
      XDB(2,1,2)=4.0D0
      XDB(2,2,1)=4.0D0
C
      XDB(2,1,1)=4.0D0
      XDB(1,2,1)=0.0D0
      XDB(1,2,2)=0.0d0
C
      REG(2,1,2)=EXP(XDB(2,1,2)*(RHH-RCH))
      REG(2,2,1)=EXP(XDB(2,2,1)*(RCH-RHH))
C
C TERSOFF-III SILICON
C
      DXL(3,3)=2.4799d0
      AXL(3,3)=1.7322d0
      DD(3,3)=1830.8d0
      AD(3,3)=471.18d0
      XTN2(3)=0.78734d0
      XTN1(3)=1/(2.0*XTN2(3))
      ADB(3)=1.0999D-6
      CDB(3)=1.0039D+5
      CDB2(3) = CDB(3)*cdb(3)
      DDB(3)=16.218d0
      DDB2(3) = DDB(3)*DDB(3)
      HDB(3)=0.59826d0
      RB1(3,3)=2.7d0
      RB2(3,3)=3.0d0
      RMAX(3,3)=RB2(3,3)
      PID(3,3)=PI/(RB2(3,3)-RB1(3,3))
      CHI(3,3) = 1.0d0
C
C TERSOFF GERMANIUM
C
      DXL(4,4) = 2.4451d0
      AXL(4,4) = 1.7047d0
      DD(4,4) = 1769.0d0
      AD(4,4) = 0.50d0 * 419.23d0
      XTN2(4) = 0.75627d0
      XTN1(4) = 1/(2.0*XTN2(4))
      ADB(4) = 9.0166d-07
      CDB(4) = 1.0643d+5
      CDB2(4) = CDB(4)*CDB(4)
      DDB(4) = 15.652D0
      DDB2(4) = DDB(4)*DDB(4)
      HDB(4) = -0.43884d0
      RB1(4,4)=2.7d0
      RB2(4,4)=3.0d0
      RMAX(4,4)=RB2(4,4)
      PID(4,4)=PI/(RB2(4,4)-RB1(4,4))
      CHI(4,4) = 1.0d0
C
C Mixed SILICON-GERMANIUM
C
      DXL(4,3) = (DXL(4,4)+DXL(3,3))/2.0d0
      DXL(3,4) = DXL(4,3)
      AXL(4,3) = (AXL(4,4)+AXL(3,3))/2.0d0
      AXL(3,4) = AXL(4,3)
      DD(4,3) = sqrt(DD(4,4)*DD(3,3))
      DD(3,4) = DD(4,3)
      AD(4,3) = sqrt(AD(3,3)*AD(4,4))
      AD(3,4) = AD(4,3)
      RB1(4,3) = sqrt(RB1(3,3)*RB1(4,4))
      RB1(3,4) = RB1(4,3)
      RB2(4,3) = sqrt(RB2(3,3)*RB2(4,4))
      RB2(3,4) = RB2(4,3)
      RMAX(4,3) = RB2(4,3)
      RMAX(3,4) = RMAX(4,3)
      PID(4,3) = PI/(RB2(4,3)-RB1(4,3))
      PID(3,4) = PID(4,3)
      CHI(4,3) = 1.00061d0
      CHI(3,4) = CHI(4,3)
c
      SIGMA=1.0d0
      EPSI=11605.0d0
C
      DO 61 I=1,4
           DO 60 J=1,4
                RLIST(I,J)=(RMAX(I,J)+RLL)**2
                RMAX(I,J)=RMAX(I,J)**2
   60      CONTINUE
   61 CONTINUE
      RETURN
110   FORMAT(4I5)
120   FORMAT(4E20.6)
      END


C
C pass data back to C code
C
      subroutine getd(pos0,vel0,acc0,r30,r40,rnp0,energy,syse)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 pos0(3,np),vel0(3,np),acc0(3,np),
     & r30(3,np),r40(3,np),rnp0(3,np),energy(np)
      include 'common_files.inc'
      DO I=1,NP
           DO N=1,3
                pos0(N,i) = R0(I,N)
                vel0(N,i) = R1(I,N)/DELTA
                acc0(N,i) = R2(I,N)
                r30(N,i) = R3(I,N)
                r40(N,i) = R4(I,N)
                rnp0(N,i) = RNP(I,N)
           ENDDO
           energy(i) = eatom(i)
      ENDDO
      syse=tote
      return
      end
